CONSOLE(1)

NAME
console - console server client program

SYNOPSIS
console [-aAEfFsS] [-7Dv] [-c cred] [-M mach] [-p port] [-e esc] [-l user] console
console [-hiIPrRuVwWx] [-7Dv] [-M mach] [-p port] [-d [user][@console]] [-[bB] message] [-t [user][@console] message]
console [-qQ] [-7Dv] [-M mach] [-p port]

DESCRIPTION
Console is used to manipulate console terminals remotely or to poll running conserver(8) daemons for status information.

In the first form above, console asks the user's password before granting interactive access to a console (on a non-trusted system), since such a session may provide single-user access. Only as much of the console name as is required to identify it uniquely to the server is required.

For non-interactive options, console outputs only the requested information and exits.

Console knows only of a primary conserver host (see the -M option below), to which it initially connects. In a multi-server environment, the primary server may refer the client to a different server handling the requested console, or it will provide a list of all servers if required (as when console is invoked with the -r option). Console then opens connections to the appropriate server(s). It is not necessary for the user of console to know which server manages which consoles, as long as console knows a valid primary server and all available consoles are listed in the primary server's configuration file.

OPTIONS

Options may be given as separate arguments (e.g., -v -w) or clustered (e.g., -vw). Options and their arguments may be separated by optional white space. Option arguments containing spaces or other characters special to the shell must be quoted.

-7  Strip the high bit off of all data received, whether from user input or from the server, before any processing occurs. Disallows escape sequence characters with the high bit set.

-a  Access a console with a two-way (read-write) connection (this is the default). The connection is dropped to spy mode if someone else is attached read-write.

-bmessage
    Broadcast a message to all users connected to each server.

-Bmessage
    Same as -b but just send a message to users on the primary server.

-ccred
    Load an SSL certificate and key from the PEM encoded file cred.

-d  Disconnect the users specified by user@console. You may specify the target as user (disconnect the user, regardless of what console they are attached to), @console (disconnect all users attached to console), or user@console (disconnect the user attached to console).

-D  Enable debugging output.

-eesc
    Set the initial two-character escape sequence to those represented by esc. Any of the forms output by cat(1)'s -v option are accepted. The default value is ``^Ec''.

-E  If encryption has been built into the code (--with-openssl), encrypted client connections are a requirement. This option allows the client to connect to a console over a non-encrypted connection.

-f  Same as -a except it will force any existing connection into spy mode.

-h  Display a brief help message.

-i  Display information in a machine-parseable format (see below for the details).

-I  Same as -i but just acts on the primary server.

-luser
    Set the login name used for authentication to user. By default, console uses $USER if its uid matches the user's real uid, or $LOGNAME if its uid matches the user's real uid, or else the name associated with the user's real uid.

-Mmach
    The console client program polls mach as the primary server, rather than the default set at compile time (typically ``console''). The default mach may be changed at compile time using the --with-master option.

-pport
    Set the port to connect to. This may be either a port number or a service name. The default port may be changed at compile time using the --with-port option.

-P  Display the pid of the master daemon process on each server.

-q  The console client connects to each server to request that the server daemon quit (shut down). The root password of the host(s) running conserver is required unless the local host is listed as ``trusted'' in the conserver.cf file; in that case, just press <return>.

-Q  Same as -q but just acts on the primary server.

-r  Display daemon versions. The console client connects to each server to request its version information.

-R  Same as -r but just acts on the primary server.

-s  Request a read-only (spy mode) connection. In this mode all the escape sequences (below) work, or report errors, but all other keyboard input is discarded.

-t  Send a text message to user@console. You may specify the target as user (send to user, regardless of what console they are attached to), @console (send to all users attached to console), or user@console (send to user attached to console).

-u  Show a list of all consoles with status (`up', `down', or `init') and attached users (user@host if attached read-write, `<spies>' if only users in spy mode, or `<none>').

-v  Be more verbose when building the connection(s). Use this option in combination with any of `show' options (below) for added benefit.

-V  Output the version and settings of the console client program and then exit.

-w  Show a list of all who are currently connected to consoles, including the hostnames where the console connections originate and the idle times. This is useful to see if anybody is actively using the console system if it becomes necessary to shut down conserver.

-W  Same as -w but just acts on the primary server.

-x  Show a list of consoles and devices.

The -A, -F, or -S options have the same effect as their lower-case variants. In addition, they each request the last 20 lines of the console output after making the connection (as if `^Ecr' were typed).

The -i option outputs information regarding each console in 15 colon-separated fields.

name
    The name of the console.

hostname,pid,socket
    The hostname, pid, and socket number of the child process managing the console.

type
    The type of console. Values will be a `/' for a local device, `|' for a command, or `!' for a remote port.

console-details
    The details regarding the console. The values here (all comma-separated) depend on the type of the console. Local devices will have values of the device file, baud rate/parity, and file descriptor for the device. Commands will have values of the command, the command's pid, the pseudo-tty, and file descriptor for the pseudo-tty. Remote ports will have values of the remote hostname, remote port number, ``raw'' or ``telnet'' protocol, and file descriptor for the socket connection.

users-list
    The details of each user connected to the console. The details for each user are an `@' separated list of `w', `r', or `s' (for read-write, read-only, or suspended), username, hostname the user is on, the user's idle time, and (for `r' and `s' users only) ``rw'' or ``ro'' (if the user wants read-write mode or not). Each user bundle is separated by commas.

state
    The state of the console. Values with either be ``up'', ``down'', or ``init''.

perm
    This value will either be ``rw'' or ``ro''. It will only be ``ro'' if the console is a local device (`/' type) and the permissions are such that the server can open the file for read, but not write.

logfile-details
    The details regarding the logging for the console. The comma-separated values will be the logfile, ``log'' or ``nolog'' (if logging is on or not - toggled via ^EcL), ``act'' or ``noact'' (if activity logging is enabled or not - the `a' timestamp option), the timestamp interval, and the file descriptor of the logfile.

break
    The default break sequence used for the console.

reup
    If the console is currently down and the automatic reconnection code is at work, it will have the value of ``autoup'', otherwise it will be ``noautoup''.

aliases
    The console aliases are presented in a comma-separated list.

options
    The active options for the console are presented in a comma-separated list.

initcmd
    The initcmd configuration option for the console.

idletimeout
    The idletimeout configuration option for the console.

idlestring
    The idlestring configuration option for the console.

ESCAPE SEQUENCES
The connection can be controlled by a two-character escape sequence, followed by a command. The default escape sequence is ``control-E c'' (octal 005 143). (The escape sequences are actually processed by the server; see the conserver(8) man page for more information.) Commands are:

.   disconnect
;   disconnect and login to another console
a   attach read-write if nobody already is
b   send broadcast message to all users on this console
c   toggle flow control (don't do this)
d   down the current console
ecc change the escape sequence to the next two characters
f   forcibly attach read-write
g   group info
i   information dump
L   toggle logging on/off
l?  list the break sequences available
l0  send the break sequence associated with this console
l1-9
    send the specific break sequence
m   display the "message of the day"
o   close (if open) and reopen the line (to clear errors (silo overflows)) and the log file
p   replay the last 60 lines of output
r   replay the last 20 lines of output
s   switch to spy mode (read-only)
u   show status of hosts/users in this group
v   show the version of the group server
w   who is using this console
x   examine this group's devices and modes
z   suspend this connection
|   attach a local command to the console
?   display list of commands
^M (return)
    continue, ignore the escape sequence
^R (ctrl-R)
    replay the last line only
\ooo
    send character having octal code ooo (must specify three octal digits)

If any other character is hit after the escape sequence, all three characters will be discarded. Note that a line break or a down command can only be sent from a full two-way attachment. To send the escape sequence through the connection one must redefine the outer escape sequence, or use ^Ec\ooo to send the first escape character before typing the second character directly.

In the -u output, the login ``<none>'' indicates no one is viewing that console, and the login ``<spies>'' indicates that no one has a full two-way attachment. When no one is attached to a console its output is cloned to the stdout of the server process if conserver was started with the -u option.

EXAMPLES

console -u
    Outputs something like:

    dumb      up      <none>
    expert    up      ksb@mentor
    tyro      up      <spies>
    mentor    up      <none>
    sage      up      fine@cis

    The <none> indicates no one is viewing dumb or mentor, the <spies> indicates only read-only connections exist for tyro, and other login@host entries indicate users attached read-write to sage and expert.

console -w
    Outputs something like:

    ksb@extra       attach  2days     expert
    file@cis        attach  21:46     sage
    dmr@alice       spy      0:04     tyro

    The third column is the idle time of the user. Either hours:minutes or number of days is displayed.

console -e "^[1" lv426
    Requests a connection to the host ``lv426'' with the escape characters set to ``escape one''.

BUGS
It is possible to create a loop of console connections, with ugly results. Never run console from within a console connection (unless you set each escape sequence differently).

The -i output can produce more than the stated number of fields of information if the user-provided information has embedded colons.

I'm sure there are more, I just don't know where they are. Please let me know if you find any.

AUTHORS
Thomas A. Fine, Ohio State Computer Science
Kevin Braunsdorf, Purdue University Computing Center
Bryan Stansell, conserver.com

SEE ALSO
conserver.cf(5), conserver.passwd(5), conserver(8)